const _Http = getApp().globalData.http;
Page({
    data: {
        loading: true,
        navList: [{
            label: "我负责的",
            icon: "icon-webxialaxuanxiangjiantou",
            color: "",
            width: "",
            id: "1"
        }, {
            label: "排序",
            icon: "icon-jiangxu1",
            color: "",
            width: "",
            id: "sort"
        }, {
            label: "筛选",
            icon: "icon-shaixuan",
            color: "",
            width: "",
            id: "2"
        }],
        classShow: false,
        content: {
            "isAll": 0,
            "nocache": true,
            deleted: 0,
            "version": 1,
            "pageNumber": 1,
            "pageSize": 20,
            type: 1,
            "where": {
                "condition": "",
            },
            "sort": []
        },
        filtrate: false,

    },
    onLoad(options) {
        getApp().globalData.Language.getLanguagePackage(this, '销售线索');
        this.setData({
            insert: wx.getStorageSync('auth').worderclue.options.some(v => v == 'insert'), //查询新增权限
            classActions: wx.getStorageSync('templetList').map((v, i) => {
                return {
                    name: v.templetname,
                    index: v.templetid,
                    color: i == 0 ? '#3874F6' : '',
                    i: i,
                }
            }),
            'navList[0].label': wx.getStorageSync('templetList')[0].templetname,
            "content.type": wx.getStorageSync('templetList')[0].templetid,
        });
        this.getList()
        this.getClueArea()
    },

    /* 获取列表 */
    getList(init = false) {
        _Http.init(this.data.content, init).then(content => {
            _Http.basic({
                "id": 20221101094502,
                content
            }).then(res => {
                console.log("线索", res)
                this.selectComponent('#ListBox').RefreshToComplete();
                if (res.code != '1') return wx.showToast({
                    title: res.data,
                    icon: "none"
                })
                this.setData({
                    content: _Http.paging(content, res),
                    list: res.pageNumber == 1 ? res.data : this.data.list.concat(res.data),
                    loading: false,
                })
                this.getTags();
            })
        })
    },
    /* 获取线索状态 */
    getClueArea() {
        let filtratelist = [];
        _Http.basic({
            "classname": "sysmanage.develop.optiontype.optiontype",
            "method": "optiontypeselect",
            "content": {
                "typename": 'clueprivate'
            }
        }).then(res => {
            console.log("线索范围", res)
            if (res.code != '1') return wx.showToast({
                title: res.data,
                icon: "none"
            })
            filtratelist.push({
                label: "线索状态",
                index: null,
                showName: "value", //显示字段
                valueKey: "status", //返回Key
                selectKey: "value", //传参 代表选着字段 不传参返回整个选择对象
                value: "", //选中值
                list: res.data
            })
            this.setData({
                filtratelist
            })
        })
        _Http.basic({
            "id": 20221223141802,
            "content": {
                "pageNumber": 1,
                "pageSize": 9999,
                "where": {
                    "condition": ""
                }
            }
        }, false).then(res => {
            console.log("获取领域", res)
            if (res.code == '1') {
                filtratelist.push({
                    label: "领域",
                    index: null,
                    showName: "tradefield", //显示字段
                    valueKey: "tradefield", //返回Key
                    selectKey: "tradefield", //传参 代表选着字段 不传参返回整个选择对象
                    value: "", //选中值
                    list: res.data
                })
                this.setData({
                    filtratelist
                })
            }
        })
        _Http.basic({
            "id": 20221013104401,
            "content": {
                "nochace": true,
                "isExport": 1,
                "pageNumber": 1,
                sys_systemtagid: 14,
                "pageSize": 1000,
                "where": {
                    "condition": ""
                }
            }
        }, false).then(res => {
            console.log("获取标签", res)
            if (res.code == '1') {
                filtratelist.push({
                    label: "标签",
                    index: null,
                    type: "checkbox",
                    showName: "tag", //显示字段
                    valueKey: "tag", //返回Key
                    selectKey: "tag", //传参 代表选着字段 不传参返回整个选择对象
                    value: "", //选中值
                    list: res.data
                })
                this.setData({
                    filtratelist
                })
            }
        })
        _Http.basic({
            "classname": "sysmanage.develop.optiontype.optiontype",
            "method": "optiontypeselect",
            "content": {
                "typename": "cluesourcesift"
            }
        }).then(res => {
            console.log("获取来源", res)
            if (res.code == '1') {
                filtratelist.push({
                    label: "来源",
                    index: null,
                    showName: "value", //显示字段
                    valueKey: "cluesource", //返回Key
                    selectKey: "value", //传参 代表选着字段 不传参返回整个选择对象
                    value: "", //选中值
                    list: res.data
                })
                this.setData({
                    filtratelist
                })
            }
        })
    },

    /* 处理搜索 */
    onSearch({
        detail
    }) {
        this.setData({
            "content.where.condition": detail
        });
        this.getList(true);
    },
    /* 获取列表标签 */
    getTags() {
        let list = this.data.list,
            ownerids = list.map(v => v.sat_orderclueid);
        _Http.basic({
            "id": 20221018102001,
            "content": {
                nocache: true,
                "ownertable": "sat_orderclue",
                ownerids
            }
        }).then(res => {
            console.log("标签", res)
            for (let key in res.data) {
                let index = list.findIndex(v => v.sat_orderclueid == key);
                list[index].tags = res.data[key]
            };
            this.setData({
                list
            })
        })
    },
    /* 去添加 */
    openType() {
        wx.navigateTo({
            url: '/packageA/saleClue/addClue',
        })
    },
    /* 选择添加报价形式 */
    typeSelect({
        detail
    }) {
        wx.navigateTo({
            url: detail.name == '项目报价' ? '/packageA/offers/addProjectOffer' : '/packageA/offers/addSetclientOffer',
        });
        this.typeCancel();
    },
    /* 顶部条件导航回调 */
    navClick({
        detail
    }) {
        switch (detail.id) {
            case '1':
                this.setData({
                    classShow: true
                })
                break;
            case '2':
                this.setData({
                    filtrate: true
                })
                break;
        }
    },
    classClose() {
        this.setData({
            classShow: false
        })
    },
    classSelect({
        detail
    }) {
        if (this.data.content.type == detail.index) return this.classClose();
        this.setData({
            "content.type": detail.index,
            'navList[0].label': detail.name,
            classActions: this.data.classActions.map(v => {
                v.color = detail.i == v.i ? '#3874F6' : ''
                return v
            })
        })
        this.classClose();
        this.getList(true)
    },
    /* 处理筛选 */
    handleFilter({
        detail
    }) {
        detail.condition = this.data.content.where.condition;
        this.data.content.where = detail;
        this.getList(true)
    }
})